unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, acClasses, acThread;

type
  TForm1 = class(TForm)
    StartBtn: TButton;
    StopBtn: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    acThread1: TacThread;
    SuspendBox: TCheckBox;
    StartBtn2: TButton;
    StopBtn2: TButton;
    ListBox2: TListBox;
    Label2: TLabel;
    SuspendBox2: TCheckBox;
    acThread2: TacThread;
    PrBox1: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    PrBox2: TComboBox;
    procedure StartBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure SuspendBoxClick(Sender: TObject);
    procedure acThread1Execute(Sender: TObject);
    procedure acThread1Terminate(Sender: TObject);
    procedure StartBtn2Click(Sender: TObject);
    procedure StopBtn2Click(Sender: TObject);
    procedure SuspendBox2Click(Sender: TObject);
    procedure PrBox1Change(Sender: TObject);
    procedure PrBox2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FileName1, FileName2: String;

    procedure SyncFileFound1;
    procedure SyncFileFound2;
    procedure FixButtonState;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FixButtonState;
begin
  PrBox1.ItemIndex := Integer(acThread1.Priority);
  PrBox2.ItemIndex := Integer(acThread2.Priority);

  StartBtn.Enabled := not acThread1.Running;
  StopBtn.Enabled := acThread1.Running;
  SuspendBox.Checked := acThread1.Suspended or not acThread1.Running;

  StartBtn2.Enabled := not acThread2.Running;
  StopBtn2.Enabled := acThread2.Running;
  SuspendBox2.Checked := acThread2.Suspended or not acThread2.Running;
end;

procedure TForm1.StartBtnClick(Sender: TObject);
begin
  ListBox1.Clear;
  acThread1.Execute;
  FixButtonState;
end;

procedure TForm1.StopBtnClick(Sender: TObject);
begin
  acThread1.Terminate(False);
  FixButtonState;
end;

procedure TForm1.SuspendBoxClick(Sender: TObject);
begin
  acThread1.Suspended := SuspendBox.Checked;
end;

procedure TForm1.StartBtn2Click(Sender: TObject);
begin
  ListBox2.Clear;
  acThread2.Execute;
  FixButtonState;
end;

procedure TForm1.StopBtn2Click(Sender: TObject);
begin
  acThread2.Terminate(False);
  FixButtonState;
end;

procedure TForm1.SuspendBox2Click(Sender: TObject);
begin
  acThread2.Suspended := SuspendBox2.Checked;
end;

procedure TForm1.SyncFileFound1;
begin
  ListBox1.Items.Add(FileName1);
  Label1.Caption := 'Files: ' + IntToStr(ListBox1.Items.Count);
end;

procedure TForm1.SyncFileFound2;
begin
  ListBox2.Items.Add(FileName2);
  Label2.Caption := 'Files: ' + IntToStr(ListBox2.Items.Count);
end;

procedure TForm1.acThread1Execute(Sender: TObject);

  procedure ScanDir(Dir: String);
  var
    FindHandle: THandle;
    FindData: TWin32FindData;
  begin
    FindHandle := FindFirstFile(PChar(Dir + '*.*'), FindData);
    if FindHandle <> INVALID_HANDLE_VALUE then
     try
       repeat
         if (String(FindData.cFileName) <> '.') and
            (String(FindData.cFileName) <> '..') then
          begin
           if Sender = acThread1 then
            begin
             FileName1 := Dir + FindData.cFileName;
             acThread1.Synchronize(SyncFileFound1);
            end
           else
            begin
             FileName2 := Dir + FindData.cFileName;
             acThread2.Synchronize(SyncFileFound2);             
            end;

           if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY = FILE_ATTRIBUTE_DIRECTORY) then
             ScanDir(Dir + FindData.cFileName + '\');
          end;
       until not FindNextFile(FindHandle, FindData) or (Sender as TacThread).Terminated
     finally
       Windows.FindClose(FindHandle);
    end;
  end;

begin
  ScanDir('c:\');
end;

procedure TForm1.acThread1Terminate(Sender: TObject);
begin
  FixButtonState;
end;

procedure TForm1.PrBox1Change(Sender: TObject);
begin
  acThread1.Priority := TThreadPriority(PrBox1.ItemIndex);
end;

procedure TForm1.PrBox2Change(Sender: TObject);
begin
  acThread2.Priority := TThreadPriority(PrBox2.ItemIndex);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FixButtonState;
end;

end.
